accordion/urls.py
from . import views
from django.urls import path

app_name = 'accordion'

urlpatterns = [
    path('', views.index, name='index'),
]

buku/urls.py
from . import views
from django.urls import path

app_name = 'buku'

urlpatterns = [
    path('', views.index, name='index'),
    path('getBook/', views.get_book_response, name='get_book'),
]

home/urls.py
from django.urls import path
from . import views

app_name = 'home'

urlpatterns = [
    path('', views.index, name='index')
]

homev2/urls.py
from django.urls import path
from . import views

app_name = 'homev2'

urlpatterns = [
    path('', views.index, name='index'),
    path('gallery/', views.gallery, name='gallery'),
]

kegiatan/urls.py
from . import views
from django.urls import path

app_name = 'kegiatan'

urlpatterns = [
    path('', views.index, name='index'),
    path('add-todo/', views.add_todo, name='add_todo'),
    path('add-person/', views.add_person, name='add_person'),
]

matakuliah/urls.py
from django.urls import path
from . import views

app_name = 'matakuliah'

urlpatterns = [
    path('create_matkul/', views.create_matakuliah_view, name='create_matkul'),
    path('', views.matakuliah, name='matakuliah'),
    path('delete_matkul/', views.delete_matkul, name='delete_matkul'),
    path('detail/<str:id>', views.detail_matkul_view, name='detail_matkul'),
]

ppwStory/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('oldhome', include('home.urls')),
    path('', include('homev2.urls')),
    path('matakuliah/', include('matakuliah.urls')),
    path('kegiatan/', include('kegiatan.urls')),
    path('accordion/', include('accordion.urls')),
    path('buku/', include('buku.urls')),
    path('user/', include('user.urls')),
]

user/urls.py
from . import views
from django.urls import path

app_name = 'user'

urlpatterns = [
    path('login/', views.log_in, name='login'),
    path('register/', views.register, name='register'),
    path('logout/', views.log_out, name='logout'),
]

accordion/models.py
from django.db import models

# Create your models here.

buku/models.py
from django.db import models

# Create your models here.

home/models.py
from django.db import models

# Create your models here.

homev2/models.py
from django.db import models

kegiatan/models.py
from django.db import models

# Create your models here.
class Todo(models.Model):
    title = models.CharField(max_length=255)
    description = models.TextField()

    def __str__(self):
        return self.title

class Person(models.Model):
    name = models.CharField(max_length=255)
    todo = models.ForeignKey(Todo, on_delete=models.CASCADE)

    def __str__(self):
        return self.name

user/models.py
from django.db import models

# Create your models here.

kegiatan/forms.py
from django import forms
from .models import Todo, Person

class TodoForm(forms.ModelForm):

    class Meta:
        model = Todo
        fields = "__all__"

class PersonForm(forms.ModelForm):

    class Meta:
        model = Person
        fields = "__all__"

matakuliah/forms.py
from django import forms
from .models import MataKuliah


class MataKuliahForm(forms.ModelForm):

    class Meta:
        model = MataKuliah
        fields = "__all__"

accordion/views.py
from django.shortcuts import render

# Create your views here.
def index(request):
    return render(request, 'accordion/index.html')

buku/views.py
from django.shortcuts import render, redirect
from django.http import JsonResponse

# Create your views here.
def index(request):
    return render(request, 'buku/index.html')

def get_book_response(request):
    search_query = request.GET.get('query')
    # Ganti API Key dengan key pribadi
    url = f"https://www.googleapis.com/books/v1/volumes?q={search_query}"
    return redirect(url)

home/views.py
from django.shortcuts import render

# Create your views here.
def index(request):
    return render(request, 'home/index.html')

homev2/views.py
from django.shortcuts import render


# Create your views here.
def index(request):
    return render(request, 'homev2/index.html')


def gallery(request):
    return render(request, 'homev2/gallery.html')

kegiatan/views.py
from django.shortcuts import render, redirect, get_object_or_404
from .forms import TodoForm, PersonForm
from .models import Todo, Person
# Create your views here.


def index(request):
    list_kegiatan = Todo.objects.all()
    people = Person.objects.all()
    context = {'list_kegiatan': list_kegiatan, 'people': people}
    person_form = PersonForm()
    context['person_form'] = person_form
    return render(request, 'kegiatan/index.html', context)


def add_todo(request):
    form = TodoForm()
    context = {}
    if request.method == 'POST':
        form = TodoForm(request.POST)
        if form.is_valid():
            form.save()
        return redirect('/kegiatan/')
    else:
        context['form'] = form
        return render(request, 'kegiatan/add_todo.html', context)


def add_person(request):

    if request.method == 'POST':
        form = PersonForm(request.POST)
        if form.is_valid():
            form.save()
    return redirect('/kegiatan/')

user/views.py
from django.contrib.auth.decorators import login_required
from django.shortcuts import render, redirect
from django.contrib.auth import login, authenticate, logout
from django.contrib.auth.forms import UserCreationForm
from django.contrib import messages
# Create your views here.
def log_in(request):

    if request.method == 'POST':
        username = request.POST['username']
        password = request.POST['password']
        user = authenticate(request, username=username, password=password)
        if user is not None:
            login(request, user)
            return redirect('/')
        else:
            messages.error(request, "Invalid username or password")

    return render(request, 'user/login.html')

def register(request):
    if request.method == 'POST':
        form = UserCreationForm(request.POST)
        if form.is_valid():
            form.save()
            return redirect('/')
        else:
            messages.error(request, 'Invalid username or password')

    return render(request, 'user/register.html')

def log_out(request):
    user = request.user
    logout(request)
    return redirect('/')

templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    {% load static %}
    <link rel="stylesheet" href="{% static 'css/style.css' %}">
    {% load bootstrap4 %}
    {% bootstrap_css %}
    {% bootstrap_javascript jquery='full' %}
    <meta charset="UTF-8">
    <style>
        body {
            background-color: #1C2321;
            background-image: url({% static 'background.svg' %});
            background-size: 100% auto;
        }
    </style>
    {% block meta %}
    {% endblock meta %}
</head>
<body>
<div class="page-header">
    <nav class="navbar fixed-top navbar-expand-sm bg-palette-3-dark">
        <div class="container">
            <a class="navbar-brand text-palette-5 navbar-font-size" href="#">Fadhil's Story</a>
            <ul class="nav navbar-nav ml-auto navbar-font-size">
                <li class="nav-item">
                    <a class="nav-link text-palette-5" href="{% url 'homev2:index' %}">Home</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link text-palette-5" href="{% url 'homev2:index' %}#page-1">About</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link text-palette-5" href="{% url 'homev2:index' %}#page-2">Experience</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link text-palette-5" href="{% url 'homev2:index' %}#page-3">Contact</a>
                </li>
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle text-palette-5" href="#" id="navbarDropdown" role="button"
                       data-toggle="dropdown"
                       aria-haspopup="true" aria-expanded="false">
                        Story
                    </a>
                    <div class="dropdown-menu bg-dark" aria-labelledby="navbarDropdown">
                        <a class="dropdown-item text-palette-5" href="{% url 'home:index' %}">Story 1</a>
                        <a class="dropdown-item text-palette-5" href="{% url 'homev2:index' %}">Story 4</a>
                        <a class="dropdown-item text-palette-5" href="{% url 'matakuliah:matakuliah' %}">Story 5</a>
                        <a class="dropdown-item text-palette-5" href="{% url 'kegiatan:index' %}">Story 6</a>
                        <a class="dropdown-item text-palette-5" href="{% url 'accordion:index' %}">Story 7</a>
                        <a class="dropdown-item text-palette-5" href="{% url 'user:login' %}">Story 9</a>
                    </div>
                </li>
                <li class="nav-item">
                    <a class="nav-link text-palette-5" href="{% url 'homev2:gallery' %}">Gallery</a>
                </li>
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle text-palette-5" href="#" id="navbarDropdown2" role="button"
                       data-toggle="dropdown"
                       aria-haspopup="true" aria-expanded="false">
                        Activites
                    </a>
                    <div class="dropdown-menu bg-dark" aria-labelledby="navbarDropdown2">
                        <a class="nav-link text-palette-5" href="{% url 'matakuliah:matakuliah' %}">Matakuliah</a>
                        <a class="nav-link text-palette-5" href="{% url 'kegiatan:index' %}">Kegiatan</a>
                    </div>
                </li>
                {% if request.user.username %}
                    <li><p>Hello, {{ request.user.username }}</p></li>
                    <li><a href="{% url 'user:logout' %}">Logout</a> </li>
                {% else %}
                    <li><a href="{% url 'user:login' %}">Login</a></li>
                    <li><a href="{% url 'user:register' %}">Sign Up</a></li>
                {% endif %}
            </ul>
        </div>
    </nav>
</div>
<div class="content container">
    <div class="row">
        <div class="col">
            {% block content %}
            {% endblock %}
        </div>
    </div>
</div>
</body>
</html>